###################################################
### chunk number 1: 
###################################################
library(MiscPsycho)
library(statmod)
options(width=70)


###################################################
### chunk number 2: 
###################################################
set.seed(1)
dat <- simRasch(200, 10)


###################################################
### chunk number 3: 
###################################################
str(dat)


###################################################
### chunk number 4: 
###################################################
itemDat <- dat$data
ff <- as.formula(paste('~', paste( names(itemDat), collapse= "+")))
(aa <- alpha(ff, itemDat))
summary(aa)


###################################################
### chunk number 5: 
###################################################
(aa <- classical(ff, data = itemDat))
summary(aa)


###################################################
### chunk number 6: 
###################################################
itemDat$group <- gl(10,20)
(aa <- classical(ff, data = itemDat, design = TRUE, group = group))
summary(aa)


###################################################
### chunk number 7: 
###################################################
(fm1 <- jml(ff, itemDat, bias = TRUE))
summary(fm1)
coef(fm1)


###################################################
### chunk number 8:  eval=FALSE
###################################################
## plot(fm1)
## plot(fm1, all = FALSE, item = 3, pch = 2, lty = 1)


###################################################
### chunk number 9: 
###################################################
(ss <- scoreCon(coef(fm1)))
summary(ss)


###################################################
### chunk number 10: 
###################################################
alpha <- c(1,2)
beta <- c(0,1)
guess <- c(0,0)
params <- list("3pl" = list(a = alpha, b = beta, c = guess), 
               "gpcm" = NULL)
params


###################################################
### chunk number 11: 
###################################################
x <- c(1,0) # correct/incorrect
irt.ability(x, params, ind.dichot = c(1,2), method = "MLE")
irt.ability(x, params, ind.dichot = c(1,2), method = "MAP")
irt.ability(x, params, ind.dichot = c(1,2), method = "EAP")


###################################################
### chunk number 12: 
###################################################
irt.ability(x, params, ind.dichot = c(1,2), method = "MAP", control=list(mu=.5, sigma=1.2))


###################################################
### chunk number 13: 
###################################################
params <- list("3pl" = list(a = c(1,1), b = c(0, 1), c = c(0,0)),
               "gpcm" = list(a = c(1,1), d = list(item1 = c(0,1,2,3,4), item2 = c(0,.5,1, 1.5))))


###################################################
### chunk number 14: 
###################################################
x <- c(0,1,2,2)
irt.ability(x, params, ind.dichot = c(1,2), method = "MLE")
irt.ability(x, params, ind.dichot = c(1,2), method = "MAP")
irt.ability(x, params, ind.dichot = c(1,2), method = "EAP")


###################################################
### chunk number 15: 
###################################################
# if all are polytomous
params <- list("3pl" = NULL, "gpcm" = list(a = c(1,1), d = list(item1 = c(0,1,2,3,4), item2 = c(0,.5,1, 1.5))))
irt.ability(c(2,3), params, method = "MLE")
irt.ability(c(2,3), params, method = "MAP")
irt.ability(c(2,3), params, method = "EAP")


###################################################
### chunk number 16: 
###################################################
params <- list("3pl" = list(a = rep(1,10), b = coef(fm1), c = rep(0,10)), 
               "gpcm" = NULL)
x <- c(1,1,1,1,1,0,0,0,0,0)
irt.ability(x, params, ind.dichot = c(1:10), method = "MLE", control=list(D = 1))


###################################################
### chunk number 17: 
###################################################
tt <- as.list(coef(fm1))
ll <- lapply(tt, function(x) c(0,x))
params <- list("3pl" = NULL, "gpcm" = list(a = rep(1,10), d = ll))
x <- c(1,1,1,1,1,2,2,2,2,2)
irt.ability(x, params, method = "MLE", control=list(D = 1))


###################################################
### chunk number 18: 
###################################################
params <- list("3pl" = list(a = c(1,1), b = c(0, 1), c = c(0,0)),
               "gpcm" = list(a = c(1,1), d = list(item1 = c(0,1,2,3,4), item2 = c(0,.5,1, 1.5))))
plaus.val(x = c(0,1,2,2), params = params, ind.dichot = c(1,2))


###################################################
### chunk number 19: 
###################################################
aa <- plaus.val(x = c(0,1,2,2), params = params, ind.dichot = c(1,2), PV = 1000)
mean(aa)


###################################################
### chunk number 20: 
###################################################
irt.ability(x = c(0,1,2,2), params = params, ind.dichot = c(1,2), method = "EAP")


###################################################
### chunk number 21: 
###################################################
posterior(x = c(0,1,2,2), theta = 1, params = params, ind.dichot = c(1,2))


###################################################
### chunk number 22: 
###################################################
head(dat$data)


###################################################
### chunk number 23: 
###################################################
x <- as.numeric(dat$data[1,])
params <- list("3pl" = list(a = rep(1,10), b = coef(fm1), c = rep(0,10)), 
               "gpcm" = NULL)
rr <- class.acc(x, prof_cut = 0, params = params, ind.dichot = c(1:10), aboveC = TRUE, control=list(D=1))
rr


###################################################
### chunk number 24: 
###################################################
x <- as.numeric(dat$data[4,])
rr <- class.acc(x, prof_cut = 0, params = params, ind.dichot = c(1:10), aboveC = FALSE, control=list(D=1))
rr


###################################################
### chunk number 25: 
###################################################
a <- c(1.45, 1.84, 2.55, 2.27, 3.68, 4.07, 2.26, 1.87, 2.19, 1.33)
b <- c(-.6, -.82, -1.6, -.87, -1.41, -1.33, -1.16, -.11, -.64, -1.23)
params <- list("3pl" = list(a = a, b = b, c = rep(0, 10)), 
               "gpcm" = NULL)
x <- c(rep(0,9),1)
rr <- irt.ability(x, params, ind.dichot = c(1:10), method = "EAP")
rr


###################################################
### chunk number 26: 
###################################################
rr <- class.acc(x, prof_cut = -1.5, params, ind.dichot = c(1:10), aboveC=TRUE)
rr


###################################################
### chunk number 27: 
###################################################
tmp <- data.frame(ID = 1:100, mathScore = rnorm(100), readScore = rnorm(100), scienceScore = rnorm(100))


###################################################
### chunk number 28: 
###################################################
(result <- SSI(mathScore ~ readScore + scienceScore, tmp, k = 20, id=ID, na.action = na.omit))
summary(result)
head(result$model.frame)


###################################################
### chunk number 29: 
###################################################
 NumStu   <- 30
     NumItems <- 50
     dat <- matrix(0, nrow=NumStu, ncol=NumItems) 
     set.seed(1234)
     for(i in 1:NumStu){
        dat[i,] <- sample(1:4, NumItems, replace=TRUE)
     }
dat <- data.frame(dat)
     
## Add in explicit answer copying 
dat[(NumStu+1),] <- dat[NumStu,]
dat[(NumStu+2),] <- c(dat[(NumStu-1), 1:25], dat[(NumStu-2), 26:50 ])
     
## Answer Key
set.seed(1234)
key <- sample(1:4, NumItems, replace=TRUE)


###################################################
### chunk number 30: 
###################################################
ff <- as.formula(paste('~', paste( names(dat), collapse= "+")))
## See wrongProb help page
mm <- wrongProb(ff, data = dat, key = key)


###################################################
### chunk number 31: 
###################################################
(result <- cheat(ff, data = dat, key = key, wrongChoice = mm))
summary(result)


###################################################
### chunk number 32:  eval=FALSE
###################################################
## teachers <- unique(dat$TeacherName)
## result <- numeric(length(teachers))
## for(i in seq_along(teachers)){
## 	tmp <- cheat(~item1 + item2 + item3, dat, wrongChoice = mm, key = key, rfa='bsct', subset=TeacherName==
## 	teachers[i], na.action=NULL)
## 	result[i] <- summary(tmp)$Ncheat
## }


###################################################
### chunk number 33: 
###################################################
params1 <- list("3pl" = list(a = c(.4,1.7,1.2), b = c(-1.1, .9,2.2), c = c(.1,.2,.1)), "gpcm" = NULL)
params2 <- list("3pl" = list(a = c(.5,1.6,1), b = c(-1.5, .5,2), c = c(.1,.2,.1)), "gpcm" = NULL)


###################################################
### chunk number 34: 
###################################################
SL(params1, params2, control=list(Q=30, mu=0, sigma=1))


###################################################
### chunk number 35: 
###################################################
stringMatch('William Clinton', 'Bill Clinton', normalize='NO')


###################################################
### chunk number 36: 
###################################################
stringMatch('William Clinton', 'Bill Clinton', normalize='YES')


###################################################
### chunk number 37: 
###################################################
stringMatch('Bill Clinton', 'bill Clinton', normalize='YES', case.sensitive = FALSE)


###################################################
### chunk number 38: 
###################################################
stringMatch('Bill Clinton', 'bill Clinton', normalize='YES', case.sensitive = TRUE)


###################################################
### chunk number 39: 
###################################################
dat <- data.frame(fname1 = c('Joseph McCall', 'Paul Jones', 'Larry Everett', 'Sam Thompson', 'Sally Fields', 'Doug Carter', 'Bill Friendly', 'Tom Davison', 'Frank Mann', 'Mary Jones'),
     fname2 = c('Joe McCall', 'Paul Jones', 'Barry Everett', 'Samuel Thompson', 'Sally Fields', 'Douglas Carter', 'William Friend', 'Tommy Davison', 'Franklin Mann', 'Cary Jones'))
     
## Randomly sample five names from the data.
stringProbs(dat, N=5)


